#!/bin/sh
#
if [ $# -ne 3 ] 
	then
	echo "Usage:"
	echo "./DB2Upgrade71.sh database user password"
	echo "where database is the name of the database to be populated"
	echo "where user is the DB2 server operating system user name"
	echo "where password is the password of the user"
	exit 127;
fi

database=$1
user=$2
password=$3
#

db2 -v DETACH 
db2 -v CONNECT RESET 

db2 -v connect to $database user $user using $password >> update.log 

db2 -tvf@ -f DB2SchemaUpgrade71.sql >> update.log 

db2 -v connect reset >> update.log 

echo "Database update complete. Check update.log for messages and errors."

exit 0
#
